diff --git a/src/main/java/net/minecraft/client/render/LightmapHelper.java b/src/main/java/net/minecraft/client/render/LightmapHelper.java
new file mode 100644
index 000000000..6be738409
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/LightmapHelper.java
@@ -0,0 +1,272 @@
+package net.minecraft.client.render;
+
+import static org.lwjgl.opengl.GL11.*;
+import static org.lwjgl.opengl.GL13.*;
+
+import java.nio.ByteBuffer;
+
+import net.minecraft.client.GLAllocation;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.enums.LightmapStyle;
+import net.minecraft.core.util.helper.Buffer;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+public class LightmapHelper {
+	private static LightmapHelper instance = null;
+
+	public static boolean isLightmapEnabled() {
+		return instance != null && instance.isEnabled();
+	}
+
+	public final Minecraft mc;
+	public final WorldRenderer worldRenderer;
+
+	private int lightmapTexture = 0;
+	private int[] lightmapData = new int[256];
+
+	public LightmapHelper(Minecraft mc, WorldRenderer worldRenderer) {
+		this.mc = mc;
+		this.worldRenderer = worldRenderer;
+		instance = this;
+	}
+
+	public boolean isEnabled() {
+		return mc.gameSettings.lightmapStyle.value != LightmapStyle.DISABLED;
+	}
+
+	public void update(float partialTicks) {
+		World world = mc.theWorld;
+
+		if(!isEnabled() || world == null) {
+			return;
+		}
+
+		if(mc.fullbright) {
+			for(int i = 0; i < lightmapData.length; i++) {
+				lightmapData[i] = 0xFFFFFFFF;
+			}
+		} else {
+			switch (mc.gameSettings.lightmapStyle.value) {
+				case DEFAULT:
+					generateGrayLightmap(world, partialTicks);
+					break;
+				case COSY:
+					generateVanillaLightmap(world, partialTicks);
+					break;
+			}
+		}
+
+		OpenGLHelper.checkError("pre generate lightmap");
+		setLightmapTextureData(lightmapData);
+		OpenGLHelper.checkError("generate lightmap");
+	}
+
+	public void disableLightmapRendering() {
+		glClientActiveTexture(GL_TEXTURE1);
+		glActiveTexture(GL_TEXTURE1);
+
+		glDisable(GL_TEXTURE_2D);
+
+		glClientActiveTexture(GL_TEXTURE0);
+		glActiveTexture(GL_TEXTURE0);
+	}
+
+	public void enableLightmapRendering() {
+		if(!isEnabled()) {
+			return;
+		}
+
+		OpenGLHelper.checkError("pre enable lightmap");
+
+		// Switch active texture
+		glClientActiveTexture(GL_TEXTURE1);
+		glActiveTexture(GL_TEXTURE1);
+
+		// Setup texture matrix
+		glMatrixMode(GL_TEXTURE);
+		glLoadIdentity();
+
+		float scale = 1.0f / 256.0f;
+		glScalef(scale, scale, scale);
+		glTranslatef(8.0f, 8.0f, 8.0f);
+
+		glMatrixMode(GL_MODELVIEW);
+
+		// Bind texture
+		mc.renderEngine.bindTexture(lightmapTexture);
+
+		// Back to default texture
+		glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
+		glEnable(GL_TEXTURE_2D);
+		glClientActiveTexture(GL_TEXTURE0);
+		glActiveTexture(GL_TEXTURE0);
+
+		OpenGLHelper.checkError("enable lightmap");
+	}
+
+	public void generateGrayLightmap(World world, float partialTicks) {
+		for(int i = 0; i < 256; i++) {
+			int skyLight = i / 16;
+			int blockLight = i & 15;
+
+			skyLight = Math.max(0, skyLight - world.skyDarken);
+
+			int light = Math.max(skyLight, blockLight);
+
+			float brightness = world.worldType.getBrightnessRamp()[light];
+
+			int brightnessI = (int) (brightness * 255);
+
+			int color = 0xFF000000 | brightnessI << 16 | brightnessI << 8 | brightnessI;
+
+			lightmapData[i] = color;
+		}
+	}
+
+	public void generateVanillaLightmap(World world, float partialTicks) {
+		float ambientBrightness = world.getAmbientBrightness(partialTicks);
+		float brightness = 0.0f;
+
+		for(int i = 0; i < 256; i++) {
+			float skyLight = getBrightnessRemoveMinLight(world, i / 16) * (ambientBrightness * 0.95f + 0.05f);
+			float blockLight = getBrightnessRemoveMinLight(world, i % 16) * (0.0f * 0.1f + 1.5f);
+
+			if(world.lightningFlicker > 0) {
+				skyLight = getBrightnessRemoveMinLight(world, i / 16);
+			}
+
+			float skyRed = skyLight * (ambientBrightness * 0.65F + 0.35F);
+			float skyGreen = skyLight * (ambientBrightness * 0.65F + 0.35F);
+			float skyBlue = skyLight;
+
+			float torchRed = blockLight;
+			float torchGreen = blockLight * ((blockLight * 0.6F + 0.4F) * 0.6F + 0.4F);
+			float torchBlue = blockLight * (blockLight * blockLight * 0.6F + 0.4F);
+
+			float red = skyRed + torchRed;
+			float green = skyGreen + torchGreen;
+			float blue = skyBlue + torchBlue;
+
+			red = red * 0.96f + 0.03f;
+			green = green * 0.96f + 0.03f;
+			blue = blue * 0.96f + 0.03f;
+
+			red = MathHelper.clamp(red, 0.0f, 1.0f);
+			green = MathHelper.clamp(green, 0.0f, 1.0f);
+			blue = MathHelper.clamp(blue, 0.0f, 1.0f);
+
+			red = applyGamma(red, brightness) * 0.96f + 0.03f;
+			green = applyGamma(green, brightness) * 0.96f + 0.03f;
+			blue = applyGamma(blue, brightness) * 0.96f + 0.03f;
+
+			red = MathHelper.clamp(red, 0.0f, 1.0f);
+			green = MathHelper.clamp(green, 0.0f, 1.0f);
+			blue = MathHelper.clamp(blue, 0.0f, 1.0f);
+
+			lightmapData[i] = toIntARGB(red, green, blue);
+		}
+	}
+
+	public void setLightmapTextureData(int[] data) {
+		OpenGLHelper.checkError("pre set lightmap data");
+
+		Buffer.checkBufferSize(16 * 16 * 4);
+		ByteBuffer buffer = Buffer.buffer;
+		buffer.clear();
+
+		for(int i = 0; i < lightmapData.length; i++) {
+			int color = lightmapData[i];
+
+			int a = color >> 24;
+			int r = (color >> 16) & 0xFF;
+			int g = (color >> 8) & 0xFF;
+			int b = color & 0xFF;
+
+			buffer.put((byte) r);
+			buffer.put((byte) g);
+			buffer.put((byte) b);
+			buffer.put((byte) a);
+		}
+
+		buffer.position(0);
+		buffer.limit(16 * 16 * 4);
+
+		if(lightmapTexture == 0) {
+			lightmapTexture = GLAllocation.generateTexture();
+			glBindTexture(GL_TEXTURE_2D, lightmapTexture);
+			glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, 16, 16, 0, GL_RGBA, GL_UNSIGNED_BYTE, (ByteBuffer) null);
+		}
+
+		glBindTexture(GL_TEXTURE_2D, lightmapTexture);
+		glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 16, 16, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
+
+		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
+		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
+
+		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
+		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
+
+		OpenGLHelper.checkError("set lightmap data");
+	}
+
+	public int toIntARGB(float red, float green, float blue) {
+		int a = 255;
+		int r = (int) (red * 255);
+		int g = (int) (green * 255);
+		int b = (int) (blue * 255);
+		return (a << 24) | (r << 16) | (g << 8) | b;
+	}
+
+	public float applyGamma(float color, float gamma) {
+		float color2 = 1.0f - color;
+		color2 = 1.0f - color2 * color2 * color2 * color2;
+		return color * (1.0f - gamma) + color2 * gamma;
+	}
+
+	public float getBrightnessRemoveMinLight(World world, int i) {
+		float brightness = world.worldType.getBrightnessRamp()[i];
+		float min = 0.05f;
+
+		return (brightness - min) / (1.0f - min);
+	}
+
+	public static int getLightmapCoord(int skylight, int blocklight) {
+		return skylight << 20 | blocklight << 4;
+	}
+	
+	public static int getOverbrightLightmapCoord(int skylight) {
+		return getLightmapCoord(skylight, 15);
+	}
+	
+	public static int max(int lightmapCoord1, int lightmapCoord2) {
+		int sky1 = lightmapCoord1 >> 16;
+		int sky2 = lightmapCoord2 >> 16;
+		
+		int block1 = lightmapCoord1 & 0xFFFF;
+		int block2 = lightmapCoord2 & 0xFFFF;
+		
+		return Math.max(sky1, sky2) << 16 | Math.max(block1, block2);
+	}
+	
+	public static int avg(int lmc0, int lmc1) {
+		int sky0 = lmc0 >> 16;
+		int sky1 = lmc1 >> 16;
+		
+		int block0 = lmc0 & 0xFFFF;
+		int block1 = lmc1 & 0xFFFF;
+		
+		int sky = (sky0 + sky1) >> 1;
+		int block = (block0 + block1) >> 1;
+		
+		return sky << 16 | block;
+	}
+	
+	public static int avg(int lmc0, int lmc1, int lmc2, int lmc3) {
+//		int lmc01 = (lmc0 + lmc1) >> 1;
+//		int lmc23 = (lmc2 + lmc3) >> 1;
+//		return (lmc01 + lmc23) >> 1;
+		return avg(avg(lmc0, lmc1), avg(lmc2, lmc3));
+	}
+
+}
diff --git a/src/main/java/net/minecraft/client/render/RenderBlockCache.java b/src/main/java/net/minecraft/client/render/RenderBlockCache.java
index dd9cc7887..abcf39cfc 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlockCache.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlockCache.java
@@ -9,15 +9,23 @@ import java.util.Arrays;
 
 final public class RenderBlockCache {
     private final Minecraft mc = Minecraft.getMinecraft(this);
+    
     private static final int CACHE_RANGE = 1;
     private static final int CACHE_SIZE = CACHE_RANGE*2+1;
+    
     private final boolean[] brightnessCached = new boolean[CACHE_SIZE*CACHE_SIZE*CACHE_SIZE];
     private final float[] brightnessValue = new float[CACHE_SIZE*CACHE_SIZE*CACHE_SIZE];
+    
     private final boolean[] opacityCached = new boolean[CACHE_SIZE*CACHE_SIZE*CACHE_SIZE];
     private final boolean[] opacityValue = new boolean[CACHE_SIZE*CACHE_SIZE*CACHE_SIZE];
+    
+    private final boolean[] lightmapCoordCached = new boolean[CACHE_SIZE*CACHE_SIZE*CACHE_SIZE];
+    private final int[] lightmapCoordValue = new int[CACHE_SIZE*CACHE_SIZE*CACHE_SIZE];
+    
     private int offsetX = Integer.MAX_VALUE;
     private int offsetY = Integer.MAX_VALUE;
     private int offsetZ = Integer.MAX_VALUE;
+    
     private Block block;
     private WorldSource access;
 
@@ -27,34 +35,45 @@ final public class RenderBlockCache {
             this.access = access;
             Arrays.fill(brightnessCached, false);
             Arrays.fill(opacityCached, false);
+            Arrays.fill(lightmapCoordCached, false);
             offsetX = x;
             offsetY = y;
             offsetZ = z;
         }
     }
-    public float getBrightness(int relX, int relY, int relZ) {
-        if (mc.fullbright && (access.getBlock(relX + offsetX, relY + offsetY, relZ + offsetZ) == null || !access.isBlockOpaqueCube(relX + offsetX, relY + offsetY, relZ + offsetZ))) return 1.0f;
 
-        if(mc.isTreeShadingEnabled() && mc.isAmbientOcclusionEnabled())
-        {
-            if (access.getBlock(relX + offsetX, relY + offsetY, relZ + offsetZ) instanceof BlockLeavesBase)
-            {
-                float brightness = access.getBrightness(relX + offsetX, relY + offsetY, relZ + offsetZ, Block.lightEmission[access.getBlockId(relX + offsetX, relY + offsetY, relZ + offsetZ)]);
-                if (brightness > 0.2F)
-                {
-                    brightness = 0.2F;
-                }
-                return brightness;
-            }
-        }
-
-        int index = (relX+CACHE_RANGE)*CACHE_SIZE*CACHE_SIZE+(relY+CACHE_RANGE)*CACHE_SIZE+(relZ+CACHE_RANGE);
-        if (!brightnessCached[index]) {
-            brightnessValue[index] = block.getBlockBrightness(access, relX + offsetX, relY + offsetY, relZ + offsetZ);
-            brightnessCached[index] = true;
-        }
-        return brightnessValue[index];
-    }
+	public float getBrightness(int relX, int relY, int relZ) {
+		int x1 = relX + offsetX;
+		int y1 = relY + offsetY;
+		int z1 = relZ + offsetZ;
+		
+		if(LightmapHelper.isLightmapEnabled() || mc.fullbright) {
+			Block block = access.getBlock(x1, y1, z1);
+			if(block == null) {
+				return 1.0f;
+			}
+			return 1.0f - block.getAmbientOcclusionStrength(access, x1, y1, z1);
+		}
+		
+		if(mc.isTreeShadingEnabled() && mc.isAmbientOcclusionEnabled()) {
+			if(access.getBlock(x1, y1, z1) instanceof BlockLeavesBase) {
+				float brightness = access.getBrightness(x1, y1, z1, Block.lightEmission[access.getBlockId(x1, y1, z1)]);
+				if(brightness > 0.2F) {
+					brightness = 0.2F;
+				}
+				return brightness;
+			}
+		}
+		
+		int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
+		if(!brightnessCached[index]) {
+			brightnessValue[index] = block.getBlockBrightness(access, x1, y1, z1);
+			brightnessCached[index] = true;
+		}
+		
+		return brightnessValue[index];
+	}
+	
     public boolean getOpacity(int relX, int relY, int relZ) {
         int index = (relX+CACHE_RANGE)*CACHE_SIZE*CACHE_SIZE+(relY+CACHE_RANGE)*CACHE_SIZE+(relZ+CACHE_RANGE);
         if(!opacityCached[index]){
@@ -63,4 +82,13 @@ final public class RenderBlockCache {
         }
         return opacityValue[index];
     }
+    
+    public int getLightmapCoord(int relX, int relY, int relZ) {
+    	int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
+    	if(!lightmapCoordCached[index]) {
+    		lightmapCoordValue[index] = access.getLightmapCoord(relX + offsetX, relY + offsetY, relZ + offsetZ, Block.lightEmission[block.id]);
+    		lightmapCoordCached[index] = true;
+    	}
+    	return lightmapCoordValue[index];
+    }
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/render/RenderBlocks.java b/src/main/java/net/minecraft/client/render/RenderBlocks.java
index e53048021..e7c35ec0c 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -219,8 +219,8 @@ public class RenderBlocks
         boolean rendered = false;
         block.setBlockBoundsBasedOnSide(this.blockAccess, x, y, z, Side.getSideById(side));
         if (this.renderAllFaces || blockModel.shouldSideBeRendered(this.blockAccess, x+dirX, y+dirY, z+dirZ, side, meta)) {
-
-            setupLighting(r, g, b, side, meta,
+        	
+            setupLighting(block, x, y, z, r, g, b, side, meta,
                     dirX, dirY, dirZ, depth,
                     topX, topY, topZ, topP, botP,
                     lefX, lefY, lefZ, lefP, rigP);
@@ -242,15 +242,70 @@ public class RenderBlocks
         }
         return rendered;
     }
-    public final void setupLighting(float r, float g, float b, int side, int meta,
+    public final void setupLighting(Block block, int x, int y, int z, float r, float g, float b, int side, int meta,
                                     int dirX, int dirY, int dirZ, float depth,
                                     int topX, int topY, int topZ, float topP, float botP,
                                     int lefX, int lefY, int lefZ, float lefP, float rigP){
+    	boolean ao = mc.isAmbientOcclusionEnabled();
+        
+    	if(LightmapHelper.isLightmapEnabled()) {
+    		int lmc;
+    		if(overbright) {
+				// TODO use correct skylight value, requires a getSavedLightValue method in WorldSource
+    			lmc = LightmapHelper.getOverbrightLightmapCoord(0);
+    		}else {
+            	if(depth > FULL_CUBE_THRESHOLD) {
+            		lmc = block.getLightmapCoord(blockAccess, x, y, z);
+            	}else {
+            		lmc = block.getLightmapCoord(blockAccess, x + dirX, y + dirY, z + dirZ);
+            	}	
+    		}
+    		lightmapCoordTopLeft = lightmapCoordBottomLeft = lightmapCoordBottomRight = lightmapCoordTopRight = lmc;
+    		if(ao) {
+    			int dirX2 = dirX;
+    			int dirY2 = dirY;
+    			int dirZ2 = dirZ;
+    			
+    			if(depth > FULL_CUBE_THRESHOLD) {
+    				dirX2 = 0;
+    				dirY2 = 0;
+    				dirZ2 = 0;
+    			}
+    			
+    			boolean topT = cache.getOpacity(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
+    			boolean botT = cache.getOpacity(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
+    			boolean lefT = cache.getOpacity(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
+    			boolean rigT = cache.getOpacity(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
+    			
+    			boolean topLefT = cache.getOpacity(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ);
+    			boolean topRigT = cache.getOpacity(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ);
+    			boolean botLefT = cache.getOpacity(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ);
+    			boolean botRigT = cache.getOpacity(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ);
+    			
+    			int lmcCen = cache.getLightmapCoord(dirX2, dirY2, dirZ2);
+    			
+    			int lmcTop = topT ? lmcCen : cache.getLightmapCoord(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
+    			int lmcBot = botT ? lmcCen : cache.getLightmapCoord(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
+    			int lmcLef = lefT ? lmcCen : cache.getLightmapCoord(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
+    			int lmcRig = rigT ? lmcCen : cache.getLightmapCoord(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
+
+    			int lmcTopLef = topT && lefT ? lmcLef : (topLefT ? lmcCen : cache.getLightmapCoord(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ));
+    			int lmcBotLef = botT && lefT ? lmcLef : (botLefT ? lmcCen : cache.getLightmapCoord(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ));
+    			int lmcTopRig = topT && rigT ? lmcRig : (topRigT ? lmcCen : cache.getLightmapCoord(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ));
+    			int lmcBotRig = botT && rigT ? lmcRig : (botRigT ? lmcCen : cache.getLightmapCoord(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ));
+
+    			lightmapCoordTopLeft     = LightmapHelper.avg(lmcCen, lmcLef, lmcTop, lmcTopLef);
+    			lightmapCoordTopRight    = LightmapHelper.avg(lmcCen, lmcRig, lmcTop, lmcTopRig);
+    			lightmapCoordBottomLeft  = LightmapHelper.avg(lmcCen, lmcLef, lmcBot, lmcBotLef);
+    			lightmapCoordBottomRight = LightmapHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
+    		}
+    	}
+    	
         float lightTR;
         float lightBR;
         float lightBL;
         float lightTL;
-
+    	
         if (this.overbright) {
             lightTR = 1.0F;
             lightBR = 1.0F;
@@ -259,7 +314,7 @@ public class RenderBlocks
         } else if (this.field_22352_G <= 0) {
             lightTL = lightBL = lightBR = lightTR = cache.getBrightness(dirX, dirY, dirZ);
         } else {
-            if (mc.isAmbientOcclusionEnabled()) {
+            if (ao) {
                 {
                     float dirB = cache.getBrightness(dirX, dirY, dirZ);
                     boolean lefT = cache.getOpacity(dirX + lefX, dirY + lefY, dirZ + lefZ);
@@ -279,7 +334,7 @@ public class RenderBlocks
                     lightBR = (dirB + bB + rB + brB) / 4.0F;
                     lightBL = (lB + blB + dirB + bB) / 4.0F;
                 }
-                if(depth > 0.01){
+                if(depth > FULL_CUBE_THRESHOLD){
                     float dirB = cache.getBrightness(0, 0, 0);
                     boolean lefT = cache.getOpacity(lefX, lefY, lefZ);
                     boolean botT = cache.getOpacity(-topX, -topY, -topZ);
@@ -407,16 +462,21 @@ public class RenderBlocks
         double d15 = z + block.maxZ;
         if(enableAO)
         {
+        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.setColorOpaque_F(colorRedTopLeft, colorGreenTopLeft, colorBlueTopLeft);
             tessellator.addVertexWithUV(d11, d13, d15, d8, d10);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomLeft);
             tessellator.setColorOpaque_F(colorRedBottomLeft, colorGreenBottomLeft, colorBlueBottomLeft);
             tessellator.addVertexWithUV(d11, d13, d14, d3, d5);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomRight);
             tessellator.setColorOpaque_F(colorRedBottomRight, colorGreenBottomRight, colorBlueBottomRight);
             tessellator.addVertexWithUV(d12, d13, d14, d7, d9);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopRight);
             tessellator.setColorOpaque_F(colorRedTopRight, colorGreenTopRight, colorBlueTopRight);
             tessellator.addVertexWithUV(d12, d13, d15, d4, d6);
         } else
         {
+        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.addVertexWithUV(d11, d13, d15, d8, d10);
             tessellator.addVertexWithUV(d11, d13, d14, d3, d5);
             tessellator.addVertexWithUV(d12, d13, d14, d7, d9);
@@ -490,16 +550,21 @@ public class RenderBlocks
         double d15 = z + block.maxZ;
         if(enableAO)
         {
+        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.setColorOpaque_F(colorRedTopLeft, colorGreenTopLeft, colorBlueTopLeft);
             tessellator.addVertexWithUV(d12, d13, d15, d4, d6);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomLeft);
             tessellator.setColorOpaque_F(colorRedBottomLeft, colorGreenBottomLeft, colorBlueBottomLeft);
             tessellator.addVertexWithUV(d12, d13, d14, d7, d9);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomRight);
             tessellator.setColorOpaque_F(colorRedBottomRight, colorGreenBottomRight, colorBlueBottomRight);
             tessellator.addVertexWithUV(d11, d13, d14, d3, d5);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopRight);
             tessellator.setColorOpaque_F(colorRedTopRight, colorGreenTopRight, colorBlueTopRight);
             tessellator.addVertexWithUV(d11, d13, d15, d8, d10);
         } else
         {
+        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.addVertexWithUV(d12, d13, d15, d4, d6);
             tessellator.addVertexWithUV(d12, d13, d14, d7, d9);
             tessellator.addVertexWithUV(d11, d13, d14, d3, d5);
@@ -579,16 +644,21 @@ public class RenderBlocks
         double d16 = z + block.minZ;
         if(enableAO)
         {
+        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.setColorOpaque_F(colorRedTopLeft, colorGreenTopLeft, colorBlueTopLeft);
             tessellator.addVertexWithUV(d12, d15, d16, d8, d10);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomLeft);
             tessellator.setColorOpaque_F(colorRedBottomLeft, colorGreenBottomLeft, colorBlueBottomLeft);
             tessellator.addVertexWithUV(d13, d15, d16, d3, d5);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomRight);
             tessellator.setColorOpaque_F(colorRedBottomRight, colorGreenBottomRight, colorBlueBottomRight);
             tessellator.addVertexWithUV(d13, d14, d16, d9, d11);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopRight);
             tessellator.setColorOpaque_F(colorRedTopRight, colorGreenTopRight, colorBlueTopRight);
             tessellator.addVertexWithUV(d12, d14, d16, d4, d6);
         } else
         {
+        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.addVertexWithUV(d12, d15, d16, d8, d10);
             tessellator.addVertexWithUV(d13, d15, d16, d3, d5);
             tessellator.addVertexWithUV(d13, d14, d16, d9, d11);
@@ -661,27 +731,32 @@ public class RenderBlocks
             d10 = d5;
             d11 = d6;
         }
-        double d12 = x + block.minX;
-        double d13 = x + block.maxX;
-        double d14 = y + block.minY;
-        double d15 = y + block.maxY;
-        double d16 = z + block.maxZ;
+        double x0 = x + block.minX;
+        double x1 = x + block.maxX;
+        double y0 = y + block.minY;
+        double y1 = y + block.maxY;
+        double z0 = z + block.maxZ;
         if(enableAO)
         {
+        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.setColorOpaque_F(colorRedTopLeft, colorGreenTopLeft, colorBlueTopLeft);
-            tessellator.addVertexWithUV(d12, d15, d16, d3, d5);
+            tessellator.addVertexWithUV(x0, y1, z0, d3, d5);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomLeft);
             tessellator.setColorOpaque_F(colorRedBottomLeft, colorGreenBottomLeft, colorBlueBottomLeft);
-            tessellator.addVertexWithUV(d12, d14, d16, d9, d11);
+            tessellator.addVertexWithUV(x0, y0, z0, d9, d11);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomRight);
             tessellator.setColorOpaque_F(colorRedBottomRight, colorGreenBottomRight, colorBlueBottomRight);
-            tessellator.addVertexWithUV(d13, d14, d16, d4, d6);
+            tessellator.addVertexWithUV(x1, y0, z0, d4, d6);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopRight);
             tessellator.setColorOpaque_F(colorRedTopRight, colorGreenTopRight, colorBlueTopRight);
-            tessellator.addVertexWithUV(d13, d15, d16, d8, d10);
+            tessellator.addVertexWithUV(x1, y1, z0, d8, d10);
         } else
         {
-            tessellator.addVertexWithUV(d12, d15, d16, d3, d5);
-            tessellator.addVertexWithUV(d12, d14, d16, d9, d11);
-            tessellator.addVertexWithUV(d13, d14, d16, d4, d6);
-            tessellator.addVertexWithUV(d13, d15, d16, d8, d10);
+        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
+            tessellator.addVertexWithUV(x0, y1, z0, d3, d5);
+            tessellator.addVertexWithUV(x0, y0, z0, d9, d11);
+            tessellator.addVertexWithUV(x1, y0, z0, d4, d6);
+            tessellator.addVertexWithUV(x1, y1, z0, d8, d10);
         }
     }
 
@@ -759,16 +834,21 @@ public class RenderBlocks
         double d16 = z + block.maxZ;
         if(enableAO)
         {
+        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.setColorOpaque_F(colorRedTopLeft, colorGreenTopLeft, colorBlueTopLeft);
             tessellator.addVertexWithUV(d12, d14, d16, d8, d10);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomLeft);
             tessellator.setColorOpaque_F(colorRedBottomLeft, colorGreenBottomLeft, colorBlueBottomLeft);
             tessellator.addVertexWithUV(d12, d14, d15, d3, d5);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomRight);
             tessellator.setColorOpaque_F(colorRedBottomRight, colorGreenBottomRight, colorBlueBottomRight);
             tessellator.addVertexWithUV(d12, d13, d15, d9, d11);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopRight);
             tessellator.setColorOpaque_F(colorRedTopRight, colorGreenTopRight, colorBlueTopRight);
             tessellator.addVertexWithUV(d12, d13, d16, d4, d6);
         } else
         {
+        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.addVertexWithUV(d12, d14, d16, d8, d10);
             tessellator.addVertexWithUV(d12, d14, d15, d3, d5);
             tessellator.addVertexWithUV(d12, d13, d15, d9, d11);
@@ -849,16 +929,21 @@ public class RenderBlocks
 
         if(enableAO)
         {
+        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.setColorOpaque_F(colorRedTopLeft, colorGreenTopLeft, colorBlueTopLeft);
             tessellator.addVertexWithUV(xMax, yMin, zMax, uMin2, vMax2);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomLeft);
             tessellator.setColorOpaque_F(colorRedBottomLeft, colorGreenBottomLeft, colorBlueBottomLeft);
             tessellator.addVertexWithUV(xMax, yMin, zMin, uMax, vMax);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomRight);
             tessellator.setColorOpaque_F(colorRedBottomRight, colorGreenBottomRight, colorBlueBottomRight);
             tessellator.addVertexWithUV(xMax, yMax, zMin, uMax2, vMin2);
+            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopRight);
             tessellator.setColorOpaque_F(colorRedTopRight, colorGreenTopRight, colorBlueTopRight);
             tessellator.addVertexWithUV(xMax, yMax, zMax, uMin, vMin);
         } else
         {
+        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.addVertexWithUV(xMax, yMin, zMax, uMin2, vMax2);
             tessellator.addVertexWithUV(xMax, yMin, zMin, uMax, vMax);
             tessellator.addVertexWithUV(xMax, yMax, zMin, uMax2, vMin2);
@@ -897,6 +982,7 @@ public class RenderBlocks
     public static boolean fancyGrass = true;
 
     public static final float[] SIDE_LIGHT_MULTIPLIER = {0.5f, 1.0f, 0.8f, 0.8f, 0.6f, 0.6f};
+    public static final float FULL_CUBE_THRESHOLD = 1.0f / 16.0f;
     public boolean useInventoryTint;
     public int uvRotateEast;
     public int uvRotateWest;
@@ -918,6 +1004,10 @@ public class RenderBlocks
     public float colorBlueBottomLeft;
     public float colorBlueBottomRight;
     public float colorBlueTopRight;
+    public int lightmapCoordTopLeft;
+    public int lightmapCoordBottomLeft;
+    public int lightmapCoordBottomRight;
+    public int lightmapCoordTopRight; 
     public boolean overbright;
     public RenderBlockCache cache = new RenderBlockCache();
 
diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index b3d254975..0d21ec3bf 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1,5 +1,16 @@
 package net.minecraft.client.render;
 
+import java.nio.IntBuffer;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
+import java.util.Random;
+
+import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import org.lwjgl.opengl.ARBOcclusionQuery;
+import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL15;
+
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.fx.EntityArrowGoldenFX;
@@ -845,7 +856,7 @@ public class RenderGlobal
 
     public void drawSky(float partialTick)
     {
-        if(mc.theWorld.dimension == Dimension.nether)
+        if(mc.theWorld.dimension == Dimension.nether || mc.currentScreen instanceof GuiModelViewer)
         {
             return;
         }
@@ -1309,7 +1320,7 @@ public class RenderGlobal
 
     public void drawSelectionBox(ICamera camera, HitResult hitResult, float partialTick)
     {
-        if (mc.gameSettings.immersiveMode.drawOutline() && mc.gameSettings.blockOutlineWidth.value > 0.01f)
+        if (mc.gameSettings.immersiveMode.drawOutline() && mc.gameSettings.blockOutlineWidth.value > 0.01f && !(mc.currentScreen instanceof GuiModelViewer))
         {
             GL11.glEnable(3042 /*GL_BLEND*/);
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
@@ -1640,7 +1651,7 @@ public class RenderGlobal
         }
         if(particleId.equals("bubble"))
         {
-            mc.effectRenderer.addEffect(new EntityBubbleFX(worldObj, x, y, z, motionX, motionY, motionZ));
+            mc.effectRenderer.addEffect(new EntityBubbleFX(worldObj, x, y, z, motionX, motionY, motionZ, true));
         }
         else if(particleId.equals("smoke"))
         {
@@ -1749,6 +1760,9 @@ public class RenderGlobal
     @Override
     public void allChanged()
     {
+    	if(LightmapHelper.isLightmapEnabled()) {
+    		return;
+    	}
         for (ChunkRenderer chunkRenderer : chunkRenderers)
         {
             if (chunkRenderer.isChunkLit && !chunkRenderer.needsUpdate)
